#!/usr/local/bin/perl

##====================================================================================##
## RDFtoSSI[LWP::Simple版] for AD-EDIT ver1.2
## (c)2008-2012 NorenzPRO Ltd. TakafumiArai 2012/2/11
##
## *.shtmlへ読み込ませる場合は
## <!--#include virtual="./RDFtoSSI.cgi"-->
## のSSIタグを貼付けてご利用ください
##====================================================================================##
use CGI::Carp qw(fatalsToBrowser);
use strict;
use Encode;
use LWP::Simple;
our $rssUrl;
our $rssStart;
our $rssEnd;
our $SSIfile;
our $SSItype;
our $inCharCode;
our $outCharCode;

##=======================================================================================
## このCGIの設定
##=======================================================================================

#★RSSページのURL
#インポートするRSSのURLを、http:// から記述してください。
$rssUrl='http://adedit.blogspot.com/feeds/posts/default?alt=rss';

#★インポートするRSSページの文字コード
# shiftjis / utf8 
$inCharCode='utf8';

#★出力するSSIページの文字コード
# shiftjis / utf8 
$outCharCode='utf8';

#★表示開始記事(RSSヘッダを含める場合は0)
$rssStart=1;

#★表示終了記事
$rssEnd=5;

#★このCGIがSSI出力時に読込むデータファイルのパス
#このファイルが約1時間間隔で自動更新されます。
$SSIfile='./RDFtoSSI.dat';

#★SSI出力書式
# <ul><li>形式=[1] / <ol><li>形式=[2]
$SSItype='1';

##=======================================================================================
## メインルーチン
##=======================================================================================
our $marker;
our $line;

##現在時刻
$ENV{'TZ'} = "JST-9"; 
our ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
our $year += 1900;
our $mon++;
our $nyear = sprintf("%02d",$year);
our $nmon = sprintf("%02d",$mon);
our $nmday = sprintf("%02d",$mday);
our $nhour = sprintf("%02d",$hour);
our $nmin = sprintf("%02d",$min);
our $nDate = $nyear.$nmon.$nmday.$nhour.$nmin.'';

#データファイルの更新時間
our ($devNo,$inoNo,$ChMod,$linkLot,$uID,$gID,$rDev,$fSize,$aTime,$mTime,$cTime,$BlkSize,$Blocks) = stat($SSIfile);
our ($sec,$min,$hour,$day,$mon,$year) = localtime($mTime);
our $year += 1900;
our $mon++;
our $xyear = sprintf("%04d",$year);
our $xmon = sprintf("%02d",$mon);
our $xday = sprintf("%02d",$day);
our $xhour = sprintf("%02d",$hour);
our $xmin = sprintf("%02d",$min);
our $mDate=$xyear.$xmon.$xday.$xhour.$xmin.'';

our $PastTime=$nDate-$mDate;
if ($PastTime >= 100) {
	##RSS読込
	my $rssBody=get($rssUrl);
	Encode::_utf8_off($rssBody);
	Encode::from_to($rssBody, $inCharCode, 'utf8'); 
	$rssBody =~ s/\r//g;
	$rssBody =~ s/\n//g;
	
	##RSS-タイトル解析
	$marker='title';
	$line=1;
	our @Titles=();
	our @TitlePre=split(/<$marker>/,$rssBody);
	foreach (@TitlePre) {
		my($hit,$dummy)=split(/<\/$marker>/,$TitlePre[$line]);
		push(@Titles,$hit);
		$line++;
	}
	
	##RSS-リンク解析
	$marker='link';
	$line=1;
	our @Links=();
	our @LinkPre=split(/<$marker>/,$rssBody);
	foreach (@LinkPre) {
		my($hit,$dummy)=split(/<\/$marker>/,$LinkPre[$line]);
		push(@Links,$hit);
		$line++;
	}
	
	##SSI出力フォーマット
	our $TypeTag;
	if ($SSItype eq '1') { $TypeTag='ul'; }
	if ($SSItype eq '2') { $TypeTag='ol'; }
	our $format='<'.$TypeTag.'>';
	
	$line=$rssStart;
	for ($rssStart..$rssEnd) {
		$format=$format.'<li><a href="'.$Links[$line].'">'.$Titles[$line].'</a></li>';
		$line++;
	}
	$format=$format.'</'.$TypeTag.'>';
	Encode::_utf8_off($format);
	Encode::from_to($format, 'utf8', $outCharCode); 

	##SSIデータファイル保存
	our $tmpfile = "$$\.tmp";
	open(TMP,">$tmpfile");
	print TMP $format;
	close(TMP);
	chmod(0755,$tmpfile);
	rename($tmpfile,$SSIfile);
}

##SSIデータファイル読込出力
our $ssiOut;
if (-e $SSIfile) {
	open(READ,"$SSIfile");
	$ssiOut = <READ>;
	close(READ);
}

print "Content-type: text/html\n\n";
print $ssiOut;

exit;
##=======================================================================================
